#include "mbed.h"
#include "Milkcocoa.h"
#include "EthernetInterface.h"
#include "BD6211F.h"

EthernetInterface eth;
RawSerial pc(USBTX,USBRX);
BD6211F motor(D6,D7);

/************************* Your Milkcocoa Setup *********************************/

#define MILKCOCOA_APP_ID      "...YOUR_MILKCOCOA_APP_ID..."
#define MILKCOCOA_DATASTORE   "motor"

/************* Milkcocoa Setup (you don't need to change this!) ******************/

#define MILKCOCOA_SERVERPORT  1883

/************ Global State (you don't need to change this!) ******************/
const char MQTT_SERVER[]  = MILKCOCOA_APP_ID ".mlkcca.com";
const char MQTT_CLIENTID[] = __TIME__ MILKCOCOA_APP_ID;

extern void onpush(MQTT::MessageData& md);

int main() {
    motor = 0.0;
    
    pc.baud(9600);
    pc.printf("Milkcocoa mbed os ver demo\n\r\n\r\n\r");
    
    int ret = eth.connect();
    if (ret != 0) {
        printf("\r\nConnection error\r\n");
        return -1;
    }
    pc.printf("\n\rEthernet connected\n\r");
    
    Milkcocoa* milkcocoa = new Milkcocoa(&eth, MQTT_SERVER, MILKCOCOA_SERVERPORT, MILKCOCOA_APP_ID, MQTT_CLIENTID);
    
    milkcocoa->connect();
    
    pc.printf("%d\n\r",milkcocoa->on(MILKCOCOA_DATASTORE, "push", onpush));
    
    while(1) {
        milkcocoa->loop();
    }
}

void onpush(MQTT::MessageData& md)
{
    int control = 0;
    MQTT::Message &message = md.message;
    DataElement de = DataElement((char*)message.payload);
    control = de.getInt("Control");
    pc.printf("%d\n\r",de.getInt("Control"));
    
    motor = (float)control / 100.0;
}